﻿using JetBrains.Annotations;
using UniRx;

namespace Magify
{
    internal static class ReactivePropertyExtensions
    {
        [NotNull]
        public static NotNullReactiveProperty<T> AsNotNull<T>([NotNull] this IReactiveProperty<T> reactiveProperty, [NotNull] T defaultValueIfNull)
        {
            reactiveProperty.Value ??= defaultValueIfNull;
            return new NotNullReactiveProperty<T>(reactiveProperty);
        }
    }
}