using System.Collections.Generic;
using System.Threading;
using Magify.Model;
using Cysharp.Threading.Tasks;
using JetBrains.Annotations;

namespace Magify
{
    internal interface IServerApi
    {
        void ChangeServerUrl(EndpointUrl url);
        UniTask<CampaignsContext> GetContextAsync(ConfigScope scopes = default, CancellationToken cancellationToken = default);

        UniTask<bool> SendEvents<T>(EventType eventType, IList<T> events, CancellationToken cancellationToken = default)
            where T : class, IAnalyticsEvent;

        UniTask<PurchaseVerificationResult> VerifyPurchase(PurchaseRecord purchaseRecord, bool waitForResult, CancellationToken cancellationToken);

        UniTask<string> AuthorizeUser([NotNull] string clientId, CancellationToken cancellationToken);
        UniTask<bool> SaveState([NotNull] string appState, [CanBeNull] int? weight, CancellationToken cancellationToken);
        UniTask<string> RestoreState([CanBeNull] int? weight, CancellationToken cancellationToken);
    }
}